% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/processing.R
\name{open_app}
\alias{open_app}
\title{Open a QGIS application}
\usage{
open_app(qgis_env = set_env())
}
\arguments{
\item{qgis_env}{Environment settings containing all the paths to run the QGIS
API. For more information, refer to \code{\link[=set_env]{set_env()}}. Basically, the function
defines a few new environment variables which should not interfere with
other settings.}
}
\value{
The function enables a 'tunnel' to the Python QGIS API.
}
\description{
\code{open_app} first sets all the correct paths to the QGIS Python
binary, and secondly opens a QGIS application while importing the most
common Python modules.
}
\note{
Please note that the function changes your environment settings via
\code{\link[base:Sys.getenv]{base::Sys.getenv()}} which is necessary to run the QGIS Python API.
}
\examples{
\dontrun{
open_app()
}
}
\author{
Jannes Muenchow
}
